OpenTTD

Private Member Functions | Private Attributes
NWidgetScenarioToolbarContainer Class Reference

Container for the scenario editor's toolbar. More...

Inheritance diagram for NWidgetScenarioToolbarContainer:

## Private Member Functions
void | SetupSmallestSize (Window *w, bool init_array)
| Compute smallest size needed by the widget. More...
const byte * | GetButtonArrangement (uint &width, uint &arrangable_count, uint &button_count, uint &spacer_count) const
| Get the arrangement of the buttons for the toolbar. More...

## Private Attributes
uint | panel_widths [2]
| The width of the two panels (the text panel and date panel)

## Additional Inherited Members
Public Member Functions inherited from NWidgetToolbarContainer
bool | IsButton (WidgetType type) const
| Check whether the given widget type is a button for us. More...
void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget. More...
void | Draw (const Window *w)
| Draw the widgets of the tree. More...
NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position. More...
Public Member Functions inherited from NWidgetContainer
| NWidgetContainer (WidgetType tp)
| Constructor container baseclass. More...
void | Add (NWidgetBase *wid)
| Append widget wid to container. More...
void | FillNestedArray (NWidgetBase **array, uint length)
bool | IsEmpty ()
| Return whether the container is empty. More...
NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type. More...
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor. More...
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted (TextColour highlight_colour)
void | SetPadding (uint8 top, uint8 right, uint8 bottom, uint8 left)
| Set additional space (padding) around the widget. More...
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step. More...
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step. More...
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint). More...
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
uint | pos_x
| Horizontal position of top-left corner of the widget in the window.
uint | pos_y
| Vertical position of top-left corner of the widget in the window.
NWidgetBase * | next
| Pointer to next widget in container. Managed by parent container widget.
NWidgetBase * | prev
| Pointer to previous widget in container. Managed by parent container widget.
uint8 | padding_top
| Paddings added to the top of the widget. Managed by parent container widget.
uint8 | padding_right
| Paddings added to the right of the widget. Managed by parent container widget. (parent container may swap this with padding_left for RTL)
uint8 | padding_bottom
| Paddings added to the bottom of the widget. Managed by parent container widget.
uint8 | padding_left
| Paddings added to the left of the widget. Managed by parent container widget. (parent container may swap this with padding_right for RTL)
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height)
| Store size and position. More...
Protected Attributes inherited from NWidgetToolbarContainer
uint | spacers
| Number of spacer widgets in this toolbar.
Protected Attributes inherited from NWidgetContainer
NWidgetBase * | head
| Pointer to first widget in container.
NWidgetBase * | tail
| Pointer to last widget in container.

## Detailed Description

Container for the scenario editor's toolbar.

Definition at line 1788 of file toolbar_gui.cpp.

## Member Function Documentation

## ◆ GetButtonArrangement()

const byte* NWidgetScenarioToolbarContainer::GetButtonArrangement | ( | uint & | width,
|  | uint & | arrangable_count,
|  | uint & | button_count,
|  | uint & | spacer_count
| ) |  | const
| inline private virtual

Get the arrangement of the buttons for the toolbar.

Parameters

  width | the new width of the toolbar.
  arrangable_count | output of the number of visible items.
  button_count | output of the number of visible buttons.
  spacer_count | output of the number of spacers.

Returns
  the button configuration.

Implements NWidgetToolbarContainer.

Definition at line 1806 of file toolbar_gui.cpp.

## ◆ SetupSmallestSize()

void NWidgetScenarioToolbarContainer::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array
| ) |  |
| inline private virtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.
  init_array | Initialize the `w->nested_array`.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Reimplemented from NWidgetToolbarContainer.

Definition at line 1791 of file toolbar_gui.cpp.

References NWidgetBase::next, NWID_SPACER, and NWidgetToolbarContainer::SetupSmallestSize().

The documentation for this class was generated from the following file:

- src/toolbar_gui.cpp